// PIC18F25k20ɂ鉷xf[^K[
// Timer1݂ɂA1Ԋuŉx𑪒A24LC256Ƀf[^ۑ
//         {Tv10s
// LEDPWM쓮͖Ή

//PIC̒`t@CCN[h
#include <p18f25k20.h>

//PIC̏ݐݒ
#pragma config FOSC = INTIO67				// NbNgp

void InitI2C(void);
void InitADC(void);
void t1ms(unsigned short dat);
void t100us(void);

//*******************************************************
//***** ϐA萔̒`
unsigned char cnt;            				// cnt̓JE^
unsigned char ControlByte;                	// Control Byte
unsigned char HighAdd;                    	// High Order Address Byte
unsigned char LowAdd;                     	// Low Order Address Byte
unsigned char Data;                       	// Data Byte
unsigned char Length;                     	// Length of bytes to read
unsigned int  PageSize;                   	// Page size in bytes
unsigned char ah, al;						// AhXH,Lpϐ
short	ad_dat;								// adϊpϐ
short	old_ad_dat;							// adϊp߂邽߂̕ϐ
short	d_ad_dat;							// adϊ̍߂邽߂̕ϐ
unsigned short dat_addr;					// 24LC256֏ރAhẌʒu


//****** C֐
void main(void)                 // C֐
{
	long i;

	OSCCON = 0x60;							//PIC18F25k208MHz̓NbNœ삳B
    TRISA=0x2;                    			// |[gARA1ȊOo̓sɂ
    TRISB=0x0;                    			// |[gBׂďo̓sɂ
    TRISC=0x0;                    			// |[gCׂďo̓sɂ

	InitI2C();								// I2CC^tF[X
	InitADC();								// ADC

	cnt = 5;								// MO30~2 = 60s
	ControlByte = 0xA0;               		// Control is always A0 for reads (& with 0x01 for writes)

	// x𑪒
	PORTBbits.RB1 = 1;    					// LED_
	PORTAbits.RA0 = 1;						// RA0ɂv[ud𗬂
	t1ms(100);								// 肷܂0.1s҂
	ADCON0 |= 0x3;							// ADϊJn
	while ((ADCON0 & 0x2) != 0); 			// ϊI҂
	PORTBbits.RB1 = 0;    					// LED

	PORTCbits.RC2 = 1;						// EEPROMd
	t100us();
	HDByteWriteI2C(ControlByte, 0, 0, ADRESH);
	t1ms(10);
	HDByteWriteI2C(ControlByte, 0, 1, ADRESL);
	dat_addr = 2;							// f[^ROM̃AhX
	old_ad_dat = 256 * ADRESH + ADRESL;		// ϊf[^
	t1ms(10);
	PORTCbits.RC2 = 0;						// EEPROMdf

	T1CONbits.T1OSCEN = 1;					// T1UL
	PIE1bits.TMR1IE = 1;					// Timer1ݗL
	T1CONbits.TMR1ON = 1;					// Timer1L
	T1CON = 0xf;							// Timer1L

//**** ݂̋
    INTCONbits.GIE=1;           			// 荞݂Cl[uɂ
    INTCONbits.PEIE=1;           			// 荞݂Cl[uɂ

// [v
	while( 1 )
	{
	_asm
		SLEEP
	_endasm
	}
}

//******************************************************
//****** ݐ錾iD揇ʂgȂj
#pragma interrupt isr save = PROD
//***** ݃xN^փWv߃Zbg
#pragma code isrcode = 0x0000008
void isr_direct(void)
{ _asm  goto isr  _endasm }

//***** ݏ֐
#pragma code
void isr(void)                      // 荞݊֐
{
    if(PIR1bits.TMR1IF)
	{            // ^C}1荞݁H
        PIR1bits.TMR1IF = 0;          		// ^C}1荞݃tO0ɂ
        if(--cnt == 0)
		{               					// cnt-1Čʂ0H
            cnt = 5;                  		// cntɍXV 2x30=60s

	// x𑪒
			PORTBbits.RB1 = 1;    			// LED_
			PORTAbits.RA0 = 1;				// RA0ɂv[ud𗬂
			t1ms(100);						// 肷܂0.1s҂
			ADCON0 |= 0x3;					// ADϊJn
			while ((ADCON0 & 0x2) != 0); 	// ϊI҂
			PORTAbits.RA0 = 0;				// v[udf
			ad_dat = 256 * ADRESH + ADRESL;
			ADCON0 &= 0xfe;					// ADϊ~
			d_ad_dat = old_ad_dat - ad_dat;
			old_ad_dat = ad_dat;
			PORTBbits.RB1 = 0;				// LED

	// ϊʂ24LC256֕ۑ
			PORTCbits.RC2 = 1;				// EEPROMd
			t100us();
			ah = dat_addr >> 8;
			al = dat_addr;
			Data = (char) d_ad_dat;
			HDByteWriteI2C(ControlByte, ah, al, Data);
			dat_addr++;
			PORTCbits.RC2 = 0;				// EEPROMdf
		}
    }
}                                   

void t1ms(unsigned short dat)
{
	unsigned long i;

	i = 84 * dat;
	while (i--);
}

void t100us(void)
{
	char i;

	i = 31;
	while (i--);
}

void InitADC(void)
{
	ANSEL = 0x2;					// RA1
	ADCON0 = 0x1 << 2;				// RA1
	ADCON2 = 0x91;					// Right just., 4TAD, FOSC/8
}

void InitI2C(void)
{

  //here is the I2C setup from the Seeval32 code.
  DDRCbits.RC3 = 1; //Configure SCL
                    //as Input
	DDRCbits.RC4 = 1; //Configure SDA
                    //as Input
  SSPSTAT = 0x80;   //Disable SMBus &
                    //Slew Rate Control
  SSPCON1 = 0x28;   //Enable MSSP Master
  SSPADD = 0x18;    //Should be 0x18
                    //for 100kHz
  SSPCON2 = 0x00;   //Clear MSSP Conrol Bits
}
