$include (C8051F930.inc)               ; Include register definition file.

PUBLIC _wr_dflash
PUBLIC _erase_dflash

CODE_ASM SEGMENT CODE 

RSEG CODE_ASM ; for relocate code 

; begin function read_ppi 
USING 0 ; to tell compiler use register bank 0 

_wr_dflash: 
// precede _ must be added to tell compiler this function have return value 
// high address in R6, low address in R7 as ppi address 

			mov	DPH, R6
			mov	DPL, R7
			mov	PSCTL, #00000101b
			mov	A, R4
			mov	FLKEY, #0a5h
			mov	FLKEY, #0f1h
			movx	@DPTR, A
			mov	A, R5
			mov	FLKEY, #0a5h
			mov	FLKEY, #0f1h
			inc	DPTR
			movx	@DPTR, A
			mov	PSCTL, #00000000b
RET 

_erase_dflash: 
			mov	DPTR, #0h
			mov	PSCTL, #00000111b
			mov	FLKEY, #0a5h
			mov	FLKEY, #0f1h
			movx	@DPTR, A

			mov	DPTR, #200h
			mov	FLKEY, #0a5h
			mov	FLKEY, #0f1h
			movx	@DPTR, A
			mov	PSCTL, #00000000b
RET 

END 


